diff a/test/hotspot/jtreg/runtime/cds/appcds/applications/SpringPetClinic.java b/test/hotspot/jtreg/runtime/cds/appcds/applications/SpringPetClinic.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/applications/SpringPetClinic.java
@@ -0,0 +1,197 @@
+/*
+ * Copyright (c) 2023, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+
+/*
+ * @test id=static
+ * @key external-dep
+ * @requires vm.cds
+ * @summary run Spring Pet Clinic demo with the classic static archive workflow
+ * @library /test/lib
+ * @run driver/timeout=120 SpringPetClinic STATIC
+ */
+
+/*
+ * @test id=dynamic
+ * @key external-dep
+ * @requires vm.cds
+ * @summary run Spring Pet Clinic demo with the classic dynamic archive workflow
+ * @library /test/lib
+ * @run driver/timeout=120 SpringPetClinic DYNAMIC
+ */
+
+/*
+ * @test id=leyden
+ * @key external-dep
+ * @requires vm.cds
+ * @requires vm.cds.write.archived.java.heap
+ * @summary run Spring Pet Clinic demo with leyden-premain "new workflow"
+ * @library /test/lib
+ * @run driver/timeout=120 SpringPetClinic LEYDEN
+ */
+
+import java.io.BufferedInputStream;
+import java.io.BufferedOutputStream;
+import java.io.BufferedReader;
+import java.io.File;
+import java.io.FileOutputStream;
+import java.nio.file.Path;
+import java.util.Enumeration;
+import java.util.Map;
+import java.util.zip.ZipEntry;
+import java.util.zip.ZipFile;
+import jdk.test.lib.StringArrayUtils;
+import jdk.test.lib.artifacts.Artifact;
+import jdk.test.lib.artifacts.ArtifactResolver;
+import jdk.test.lib.cds.CDSAppTester;
+import jdk.test.lib.process.OutputAnalyzer;
+
+// NOTE: if you have not set up an artifactory, you can create spring-petclinic-3.2.0.zip by:
+//
+// - Make a clone of https://github.com/openjdk/leyden/tree/premain
+// - Change to the directory test/hotspot/jtreg/premain/spring-petclinic
+// - Edit the Makefile
+// - Run the command "make unpack"
+//
+// Then, you can add the following to your jtreg command-line to run the test cases in this directory:
+// -vmoption:-Djdk.test.lib.artifacts.spring-petclinic=/repo/test/hotspot/jtreg/premain/spring-petclinic/petclinic-snapshot/target/spring-petclinic-3.2.0.zip
+
+@Artifact(organization = "org.springframework.samples", name = "spring-petclinic", revision = "3.2.0", extension = "zip", unpack = false)
+public class SpringPetClinic {
+    public static void main(String args[]) throws Exception {
+        String cp = getArtifact();
+        SpringPetClinicTester tester = new SpringPetClinicTester(cp);
+        tester.run(args);
+    }
+
+    private static String getArtifact() throws Exception {
+        File cpFile = new File("petclinic-snapshot/target/unpacked/classpath");
+        if (!cpFile.exists()) {
+            long started = System.currentTimeMillis();
+            System.out.println("Download and extract spring-petclinic");
+
+            Map<String, Path> artifacts = ArtifactResolver.resolve(SpringPetClinic.class);
+            System.out.println(artifacts);
+            Path zip = artifacts.get("org.springframework.samples.spring-petclinic-3.2.0");
+
+            long elapsed = System.currentTimeMillis() - started;
+            System.out.println("Resolved artifacts in " + elapsed + " ms");
+
+            extractZip(zip.toString(), new File("."));
+        }
+
+        return "@" + cpFile.toString();
+    }
+
+    static void extractZip(String srcFile, File outDir) throws Exception {
+        long zipSize = (new File(srcFile)).length();
+        System.out.println("Extracting from " + srcFile + " (" + zipSize + " bytes) to " + outDir);
+
+        long started = System.currentTimeMillis();
+        try (ZipFile zipFile = new ZipFile(srcFile)) {
+            int numFiles = 0;
+            long numBytes = 0;
+            Enumeration<? extends ZipEntry> e = zipFile.entries();
+
+            byte buffer[] = new byte[1024];
+            while (e.hasMoreElements()) {
+                ZipEntry entry = e.nextElement();
+                if (!entry.isDirectory()) {
+                    File destinationPath = new File(outDir, entry.getName());
+                    destinationPath.getParentFile().mkdirs();
+
+                    numFiles ++;
+                    try (
+                         BufferedInputStream bis = new BufferedInputStream(zipFile.getInputStream(entry));
+                         FileOutputStream fos = new FileOutputStream(destinationPath);
+                         BufferedOutputStream bos = new BufferedOutputStream(fos, 1024)) {
+                        int n;
+                        while ((n = bis.read(buffer, 0, 1024)) != -1) {
+                            bos.write(buffer, 0, n);
+                            numBytes += n;
+                        }
+                    }
+                }
+            }
+            long elapsed = System.currentTimeMillis() - started;
+            System.out.println("Extracted " + numFiles + " file(s) = " + numBytes + " bytes in " + elapsed + " ms");
+        }
+    }
+
+
+    static class SpringPetClinicTester extends CDSAppTester {
+        String cp;
+
+        SpringPetClinicTester(String cp) {
+            super("SpringPetClinic");
+            this.cp = cp;
+        }
+
+        @Override
+        public String[] vmArgs(RunMode runMode) {
+            return new String[] {
+                "-Xlog:init",
+                "-DautoQuit=true",
+                "-Dspring.output.ansi.enabled=NEVER",
+                "-Dspring.aot.enabled=true",
+                "-Dserver.port=0", // use system-assigned port
+
+                // PetClinic runs very slowly in debug builds if VerifyDependencies is enabled.
+                "-XX:+IgnoreUnrecognizedVMOptions", "-XX:-VerifyDependencies",
+              //These don't seem necessary when pet-clinic is run in "Spring AOT" mode
+              //"--add-opens", "java.base/java.io=ALL-UNNAMED",
+              //"--add-opens", "java.base/java.lang=ALL-UNNAMED",
+              //"--add-opens", "java.rmi/sun.rmi.transport=ALL-UNNAMED"
+            };
+        }
+
+        @Override
+        public String classpath(RunMode runMode) {
+            return cp;
+        }
+
+        @Override
+        public String[] appCommandLine(RunMode runMode) {
+            String cmdLine[] = new String[] {
+                "org.springframework.samples.petclinic.PetClinicApplication"
+            };
+            if (runMode == RunMode.PRODUCTION) {
+                // FIXME: bug JDK-8318393
+                cmdLine = StringArrayUtils.concat("-XX:-LoadCachedCode", cmdLine);
+            }
+
+            if (runMode.isProductionRun()) {
+                cmdLine = StringArrayUtils.concat("-Xlog:scc=error", cmdLine);
+            }
+            return cmdLine;
+        }
+
+        @Override
+        public void checkExecution(OutputAnalyzer out, RunMode runMode) {
+            if (!runMode.isStaticDump()) {
+                out.shouldContain("Booted and returned in ");
+            }
+        }
+    }
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/cacheObject/ArchivedPackages.java b/test/hotspot/jtreg/runtime/cds/appcds/cacheObject/ArchivedPackages.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/cacheObject/ArchivedPackages.java
@@ -0,0 +1,107 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+/*
+ * @test
+ * @requires vm.cds.write.archived.java.heap
+ * @library /test/jdk/lib/testlibrary /test/lib
+ *          /test/hotspot/jtreg/runtime/cds/appcds/test-classes
+ * @build ArchivedPackages
+ * @run driver jdk.test.lib.helpers.ClassFileInstaller -jar app.jar ArchivedPackagesApp pkg3.Package3A pkg3.Package3B
+ * @run driver ArchivedPackages STATIC
+ */
+
+import jdk.test.lib.cds.CDSAppTester;
+import jdk.test.lib.helpers.ClassFileInstaller;
+import jdk.test.lib.process.OutputAnalyzer;
+
+import pkg3.Package3A;
+import pkg3.Package3B;
+
+public class ArchivedPackages {
+    static final String appJar = ClassFileInstaller.getJarPath("app.jar");
+    static final String mainClass = "ArchivedPackagesApp";
+
+    public static void main(String[] args) throws Exception {
+        Tester t = new Tester();
+        t.run(args);
+    }
+
+    static class Tester extends CDSAppTester {
+        public Tester() {
+            super(mainClass);
+        }
+
+        @Override
+        public String classpath(RunMode runMode) {
+            return appJar;
+        }
+
+        @Override
+        public String[] vmArgs(RunMode runMode) {
+            return new String[] {
+                "-Dcds.debug.archived.packages=true",
+                "-XX:+AOTClassLinking",
+                "-XX:+ArchivePackages"
+            };
+        }
+
+        @Override
+        public String[] appCommandLine(RunMode runMode) {
+            return new String[] {
+                mainClass,
+                runMode.name()
+            };
+        }
+
+        @Override
+        public void checkExecution(OutputAnalyzer out, RunMode runMode) {
+            if (runMode.isStaticDump()) {
+                out.shouldContain("Archiving NamedPackage \"\" for jdk.internal.loader.ClassLoaders$AppClassLoader");
+                out.shouldContain("Archiving Package \"pkg3\" for jdk.internal.loader.ClassLoaders$AppClassLoader");
+                out.shouldContain("Archiving NamedPackage \"com.sun.tools.javac\" for jdk.internal.loader.ClassLoaders$AppClassLoader");
+            } else if (runMode.isProductionRun()) {
+                out.shouldContain(ArchivedPackagesApp.msg);
+            }
+        }
+    }
+}
+
+class ArchivedPackagesApp {
+    public static String msg = "Package for archived class equals to that of non-archived class";
+    public static void main(String args[]) throws Exception {
+        Class.forName("com.sun.tools.javac.Main");
+        Package x = Package3A.class.getPackage();
+        if (args[0].equals("PRODUCTION")) {
+            Package y = Package3B.class.getPackage();
+            System.out.println("Package for archived class: " + x);
+            System.out.println("Package for non-archived class: " + y);
+            if (x == y) {
+                System.out.println(msg);
+            } else {
+                throw new RuntimeException("Unexpected for archived package");
+            }
+        }
+    }
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/cacheObject/ArchivedProtectionDomains.java b/test/hotspot/jtreg/runtime/cds/appcds/cacheObject/ArchivedProtectionDomains.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/cacheObject/ArchivedProtectionDomains.java
@@ -0,0 +1,125 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+/*
+ * @test
+ * @requires vm.cds.write.archived.java.heap
+ * @library /test/jdk/lib/testlibrary /test/lib
+ *          /test/hotspot/jtreg/runtime/cds/appcds/test-classes
+ * @build ArchivedProtectionDomains
+ * @run driver jdk.test.lib.helpers.ClassFileInstaller -jar app1.jar ArchivedProtectionDomainsApp
+ * @run driver jdk.test.lib.helpers.ClassFileInstaller -jar app2.jar pkg3.Package3A pkg3.Package3B
+ * @run driver ArchivedProtectionDomains STATIC
+ */
+
+import java.io.File;
+import java.security.ProtectionDomain;
+import jdk.test.lib.cds.CDSAppTester;
+import jdk.test.lib.helpers.ClassFileInstaller;
+import jdk.test.lib.process.OutputAnalyzer;
+import jdk.test.lib.StringArrayUtils;
+
+import pkg3.Package3A;
+import pkg3.Package3B;
+
+public class ArchivedProtectionDomains {
+    static final String app1Jar = ClassFileInstaller.getJarPath("app1.jar");
+    static final String app2Jar = ClassFileInstaller.getJarPath("app2.jar");
+    static final String mainClass = "ArchivedProtectionDomainsApp";
+
+    public static void main(String[] args) throws Exception {
+        Tester t = new Tester();
+        t.run(new String[] {args[0]});
+    }
+
+    static class Tester extends CDSAppTester {
+        public Tester() {
+            super(mainClass);
+        }
+
+        @Override
+        public String classpath(RunMode runMode) {
+            return app1Jar + File.pathSeparator + app2Jar;
+        }
+
+        @Override
+        public String[] vmArgs(RunMode runMode) {
+            String[] args = StringArrayUtils.concat(
+                "-Dcds.debug.archived.protection.domains=true",
+                "-XX:+AOTClassLinking",
+                "-XX:+ArchiveProtectionDomains",
+                "-Xlog:cds+protectiondomain");
+            return args;
+        }
+
+        @Override
+        public String[] appCommandLine(RunMode runMode) {
+            return new String[] {
+                mainClass,
+                runMode.name()
+            };
+        }
+
+        @Override
+        public void checkExecution(OutputAnalyzer out, RunMode runMode) {
+            assertArchived(out, runMode);
+        }
+
+        void assertArchived(OutputAnalyzer out, RunMode runMode) {
+            if (runMode.isStaticDump()) {
+                out.shouldMatch("Archiving ProtectionDomain .jrt:/jdk.compiler .* for jdk.internal.loader.ClassLoaders.AppClassLoader");
+                out.shouldMatch("Archiving ProtectionDomain .*app1.jar .* for jdk.internal.loader.ClassLoaders.AppClassLoader");
+                out.shouldMatch("Archiving ProtectionDomain .*app2.jar .* for jdk.internal.loader.ClassLoaders.AppClassLoader");
+            } else if (runMode.isProductionRun()) {
+                out.shouldContain("Archived protection domain for ArchivedProtectionDomainsApp = found");
+                out.shouldContain("Archived protection domain for pkg3.Package3A = found");
+                out.shouldContain("Archived protection domain for com.sun.tools.javac.Main = found");
+                out.shouldContain(ArchivedProtectionDomainsApp.msg);
+
+                // This class should not be archived.
+                out.shouldNotContain("Archived protection domain for pkg3.Package3B = found");
+                out.shouldNotContain("Archived protection domain for pkg3.Package3B = none");
+            }
+        }
+    }
+}
+
+class ArchivedProtectionDomainsApp {
+    public static String msg = "ProtectionDomain for archived class equals to that of non-archived class";
+    public static void main(String args[]) throws Exception {
+        Class jc = Class.forName("com.sun.tools.javac.Main");
+        ProtectionDomain x = Package3A.class.getProtectionDomain();
+        if (args[0].equals("PRODUCTION")) {
+            ProtectionDomain y = Package3B.class.getProtectionDomain();
+            System.out.println("ProtectionDomain for com.sun.tools.javac.Main: " + jc.getProtectionDomain());
+            System.out.println("ProtectionDomain for archived class: " + x);
+            System.out.println("ProtectionDomain for non-archived class: " + y);
+            if (x == y) {
+                System.out.println(msg);
+            } else {
+                throw new RuntimeException("Unexpected for archived package");
+            }
+        }
+    }
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/indy/IndyAndJavac.java b/test/hotspot/jtreg/runtime/cds/appcds/indy/IndyAndJavac.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/indy/IndyAndJavac.java
@@ -0,0 +1,77 @@
+/*
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+/*
+ * @test
+ * @bug 8293336
+ * @summary Test for archiving resolved invokedynamic call sites (with JavaC)
+ * @requires vm.cds.write.archived.java.heap
+ * @modules java.base/sun.invoke.util java.logging
+ * @library /test/jdk/lib/testlibrary /test/lib
+ *          /test/hotspot/jtreg/runtime/cds/appcds
+ *          /test/hotspot/jtreg/runtime/cds/appcds/test-classes
+ * @build IndyAndJavac
+ * @run driver jdk.test.lib.helpers.ClassFileInstaller -jar app.jar Dummy
+ * @run driver IndyAndJavac
+ */
+
+
+import java.io.FileWriter;
+
+import jdk.test.lib.helpers.ClassFileInstaller;
+
+public class IndyAndJavac extends IndyTestBase {
+    static final String appJar = ClassFileInstaller.getJarPath("app.jar");
+    static final String mainClass_javac = "com.sun.tools.javac.Main";
+
+    // Force some tests to be disabled during development.
+    static String forceSkip = null;
+
+    public static void main(String[] args) throws Exception {
+        setup(forceSkip, appJar);
+        testJavaC();
+    }
+
+    static void testJavaC() throws Exception {
+        String sourceFile = "Test.java";
+        try (FileWriter fw = new FileWriter(sourceFile)) {
+            fw.write("public class Test {\n");
+            for (int i = 0; i < 3000; i++) {
+                fw.write("    private static final int arr_" + i + "[] = {1, 2, 3};\n");
+                fw.write("    private static int method_" + i + "() { return arr_" + i + "[1];}\n");
+            }
+            fw.write("}\n");
+        }
+        test("Use javac with archived MethodTypes and LambdaForms", mainClass_javac, sourceFile, sourceFile,
+             RUN_STATIC |
+           //RUN_BENCH |
+             RUN_AOT
+             );
+        checkExec(null, /*lambdaFormsMustBeArchived*/false); // Some lambda forms are generated because we don't cache invokedynamic for lambda proxies yet
+    }
+}
+
+class Dummy {
+
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/indy/IndyStringConcat.java b/test/hotspot/jtreg/runtime/cds/appcds/indy/IndyStringConcat.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/indy/IndyStringConcat.java
@@ -0,0 +1,164 @@
+/*
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+/*
+ * @test
+ * @bug 8293336
+ * @summary Test for archiving resolved invokedynamic call sites
+ * @requires vm.cds.write.archived.java.heap
+ * @modules java.base/sun.invoke.util java.logging
+ * @library /test/jdk/lib/testlibrary /test/lib
+ *          /test/hotspot/jtreg/runtime/cds/appcds
+ *          /test/hotspot/jtreg/runtime/cds/appcds/test-classes
+ * @build IndyStringConcat
+ * @run driver jdk.test.lib.helpers.ClassFileInstaller -jar app.jar ConcatA ConcatA$DummyClass ConcatB
+ * @run driver IndyStringConcat
+ */
+
+
+// NOTE: to run a subset of the tests, use something like
+//
+// jtreg .... -vmoptions:-DIndyStringConcat.test.only='(1)|(2)' \
+//            -vmoptions:-DIndyStringConcat.test.skip='2' IndyStringConcat.java
+//
+// A regexp can be specified in these two properties. Note that the specified regexp must be a full match.
+// E.g., -DIndyStringConcat.test.only='1.*' matches "1" and "12", but does NOT match "21".
+// (Search for ")$" in the code below)
+//
+// Also, some tests may be forced to be skipped. To run them, edit the variable forceSkip below.
+
+import jdk.test.lib.helpers.ClassFileInstaller;
+
+public class IndyStringConcat extends IndyTestBase {
+    static final String appJar = ClassFileInstaller.getJarPath("app.jar");
+    static final String mainClass_ConcatA = ConcatA.class.getName();
+    static final String mainClass_ConcatB = ConcatB.class.getName();
+
+    // Force some tests to be disabled during development.
+    static String forceSkip = null;
+
+    public static void main(String[] args) throws Exception {
+        setup(forceSkip, appJar);
+
+        // ------------------------------------------------------------
+        test("\"LIT\" + (String)b", mainClass_ConcatA, "a");
+        checkExec("LIT222");
+
+        // ------------------------------------------------------------
+        test("(String)a + (String)b", mainClass_ConcatA, "b");
+        checkExec("aaa222");
+
+        // ------------------------------------------------------------
+        test("(String)a + (int)b", mainClass_ConcatA, "c");
+        checkExec("aaa333");
+
+        // ------------------------------------------------------------
+        test("Test with ConcatB", mainClass_ConcatB, "B1");
+        checkExec("ConcatBLIT333");
+
+        // ------------------------------------------------------------
+        test("Run ConcatB.foo() without dump-time resolution of its invokedynamic callsite", mainClass_ConcatB, "", "B1");
+        checkExec("ConcatBLIT333", /* lambdaFormsMustBeArchived*/ false);
+
+        // ------------------------------------------------------------
+        test("WithAOT (no loop) for \"LIT\" + (String)b", mainClass_ConcatA, "a", "a",  RUN_AOT);
+        checkExec("LIT222");
+        shouldUseDynamicArchive();
+
+        // ------------------------------------------------------------
+        test("WithAOT (with loop) for \"LIT\" + (String)b", mainClass_ConcatA, "loopa", "loopa",  RUN_STATIC | RUN_AOT);
+        checkExec("LITL");
+        shouldUseDynamicArchive();
+    }
+
+    static void shouldUseDynamicArchive() throws Exception {
+        shouldMatch("Opened archive IndyStringConcat-[0-9]+-dyn.jsa");
+    }
+}
+
+class ConcatA {
+    public static void main(String args[]) throws Exception {
+        if (args[0].equals("a")) {
+            foo("222");
+            System.out.print("OUTPUT = ");
+            System.out.println(x); // Avoid using + in diagnostic output.
+        } else if (args[0].equals("b")) {
+            bar("aaa", "222");
+            System.out.print("OUTPUT = ");
+            System.out.println(x); // Avoid using + in diagnostic output.
+        } else if (args[0].equals("c")) {
+            baz("aaa", 333);
+            System.out.print("OUTPUT = ");
+            System.out.println(x); // Avoid using + in diagnostic output.
+        } else if (args[0].equals("loopa")) {
+            loopa();
+            loopa();
+            System.out.print("OUTPUT = ");
+            System.out.println(x); // Avoid using + in diagnostic output.
+        }
+
+        if (args.length > 1 && args[1].equals("load-extra-class")) {
+            // Work around "There is no class to be included in the dynamic archive." problem, where the
+            // dynamic archive is not generated.
+            DummyClass.doit();
+        }
+    }
+
+    static void loopa() {
+        for (int i = 0; i < 100000; i++) {
+            foo("L");
+        }
+    }
+
+    static String x;
+    static void foo(String b) {
+        x = "LIT" + b;
+    }
+    static void bar(String a, String b) {
+        x = a + b;
+    }
+    static void baz(String a, int b) {
+        x = a + b;
+    }
+
+    static class DummyClass {
+        static void doit() {}
+    }
+}
+
+
+class ConcatB {
+    public static void main(String args[]) throws Exception {
+        if (args[0].equals("B1")) {
+            foo("333");
+            System.out.print("OUTPUT = ");
+            System.out.println(x); // Avoid using + in diagnostic output.
+        }
+    }
+
+    static String x;
+    static void foo(String b) {
+        x = "ConcatBLIT" + b;
+    }
+}
